function mesh = markFlags(mesh, v)

    loc = get_BdEdges(mesh);
    mesh.BdFlags = zeros(size(mesh.Edges,1),1);

    for edge = loc'
        norm = mesh.Coordinates(mesh.Edges(edge,1),:) - mesh.Coordinates(mesh.Edges(edge,2),:);
        norm = [-norm(2), norm(1)];

        midpoint = (mesh.Coordinates(mesh.Edges(edge,1),:) + mesh.Coordinates(mesh.Edges(edge,2),:))/2;
        elem = max(mesh.Edge2Elem(edge,:));
        vertex = setdiff(mesh.Elements(elem,:), mesh.Edges(edge,:));
        in_dir = vertex - midpoint;

        if dot(norm, in_dir) > 0
            norm = -norm;
        end

        vx = v(midpoint);

        if dot(vx, norm) < 0
            mesh.BdFlags(edge) = -1;
        else
            mesh.BdFlags(edge) = -2;
        end
    end

end
